package app

import (
	"github.com/gin-gonic/gin"

	"net/http"
)

//func SetApiBaseOutputHead(code string, message string) models.ApiBaseOutputHead {
//	var outData models.ApiBaseOutputHead
//	outData.Code = code
//	outData.Message = message
//	return outData
//}

// 失败数据处理
func Error(c *gin.Context, code string, err error, msg string) {
	var res Response
	if err != nil {
		res.ApiBaseOutputHead.Msg = err.Error()
	} else {
		if msg != "" {
			res.ApiBaseOutputHead.Msg = msg
		}
	}
	c.JSON(http.StatusOK, res.ReturnError(code))
}

// 通常成功数据处理
func OK(c *gin.Context, data interface{}, msg string) {
	var res Response
	res.Data = data
	if msg != "" {
		res.ApiBaseOutputHead.Msg = msg
	}
	c.JSON(http.StatusOK, res.ReturnOK())
}

// 分页数据处理
func PageOK(c *gin.Context, result interface{}, count int, pageIndex int, pageSize int, msg string) {
	var res PageResponse
	res.Data.List = result
	res.Data.Count = count
	res.Data.PageIndex = pageIndex
	res.Data.PageSize = pageSize

	if msg != "" {
		res.ApiBaseOutputHead.Msg = msg
	}
	c.JSON(http.StatusOK, res.ReturnOK())
}

// 分页数据处理
func PageOKUserDynamic(c *gin.Context, result interface{}, count int, pageIndex int, pageSize int, msg string, browseTotal int64, toGoTotal int64) {
	var res UserDynamicPageResponse
	res.Data.List = result
	res.Data.Count = count
	res.Data.PageIndex = pageIndex
	res.Data.PageSize = pageSize
	res.Data.BrowseTotal = browseTotal
	res.Data.ToGoTotal = toGoTotal

	if msg != "" {
		res.ApiBaseOutputHead.Msg = msg
	}
	c.JSON(http.StatusOK, res.ReturnOK())
}

// 兼容函数
func Custum(c *gin.Context, data gin.H) {
	c.JSON(http.StatusOK, data)
}
